leetcode——Find Peak Element

题目:

A peak element is an element that is greater than its neighbors.

Given an input array where num[i] ≠ num[i+1], find a peak element and return its index.

The array may contain multiple peaks, in that case return the index to any one of the peaks is fine.

You may imagine that num[-1] = num[n] = -∞.

For example, in array [1, 2, 3, 1], 3 is a peak element and your function should return the index number 2.

分析:

对于任意一个数组,只要其满足num[-1] = num[n] = -∞,且每个元素互不相等,那么必然存在局部最大值。如果数组是单调递增的,那么峰值就是最后一个元素;如果数组是单调递减的,那么峰值就是就是第一个元素;如果数组存在先增后减的区间,那么峰值显而易见;如果数组存在先减后增的区间,那么区间第一个和最后一个元素都是峰值。

因此,这道题可以使用二分查找法,通过判断先后区间是否满足上述条件从而确定峰值一定在哪个区间,递归或迭代处理那个区间就好了。

class Solution {
public:
    int findPeakElement(vector<int>& nums) {
        //二分法
        int first = 0, last = nums.size() - 1;
        while (first < last) 
        {
            int mid = first + (last - first) / 2;
            //为什么不用担心mid+1越界呢?因为如果first < last, 那么mid < last, 而last不越界
            if (nums[mid] > nums[mid + 1]) //峰值一定在区间[first, mid]
            {
                last = mid;
            }
            else //峰值一定在区间[mid+1, last]
            {
                first = mid + 1;
            }
        }
        
        return last;
    }
};


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值